/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-09-02 13:20
**/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const ll MAXN = 1500 + 9;
const ll MAXM = MAXN;
const ll INF = 1LL << 60;

// kuhn - iterative prototype
int used[MAXN], t = 1;
vector<int> edges[MAXN], ml, mr;
vector<int> eid(MAXN);
bool dfs_kuhn(int v){
  /* eid.assign(MAXN, 0); */
  stack<int> st({v});
  used[v] = t;

  bool success = 0;
  while(ssize(st) > 0){
      int v = st.top(), id = eid[v];
      if(success or id >= ssize(edges[v])){
          if(success){
              int w = edges[v][id];
              mr[w] = v, ml[v] = w;
          }
          st.pop(), eid[v] = 0;
      } else {
          int mw = mr[edges[v][id]];
          if(mw == -1) // empty the stack
              success = 1;
          else if(used[mw] < t)
              st.push(mw), used[mw] = t;
          else
              eid[v]++;
      }
  }
  return success;
}
int kuhn(int n){ // n = num vertices in V_l
  ml.assign(MAXN, -1), mr.assign(MAXM, -1);
  int cnt = 0;
  for(int i = 0; i < n; i++, t++)
    if(ml[i] == -1 && dfs_kuhn(i)) cnt++;
  return cnt;
}
// kuhn - iterative prototype

/* bool dfs_kuhn(int v){ */
/*   if(used[v] >= t) return 0; */
/*   used[v] = t; */
/*   for(int w : edges[v]) */
/*     if(mr[w] == -1 || dfs_kuhn(mr[w])) */
/*             /1* (used[mr[w]] != t && dfs_kuhn(mr[w]))) *1/ */
/*       return mr[w] = v, ml[v] = w, 1; */
/*   return 0; */
/* } */

ll M, N, K;
int trySocket(int soc){
    int a = M+1, b = M+2;
    edges[a] = edges[soc];
    edges[b] = edges[soc];
    assert(ml[a] == -1 and ml[b] == -1);
    t++;
    int x = dfs_kuhn(a);
    t++;
    int y = dfs_kuhn(b);
    return x + y;
}


void solve(){
    // Code goes here ...
    cin >> M >> N >> K;

    vector<int> (&sockets)[MAXN] = edges;
    int soc, dev;
    R(i, K){
        cin >> soc >> dev;
        sockets[soc].push_back(dev);
    }

    int res = kuhn(M+1);

    vector<int> backup_ml(ml), backup_mr(mr);
    int add = 0;
    R(i, M+1){
        add = max(add, trySocket(i));
        ml = backup_ml;
        mr = backup_mr;
    }

    cout << res + add << endl;
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    int T = 1;
    /* cin >> T; */
    while(T--)
        solve();

    return 0;
}
        
